﻿namespace ApiCore.Web.AppStart
{
    public class BaseHandlerMiddleware
    {
        protected RequestDelegate Next { get; set; }

        public BaseHandlerMiddleware(RequestDelegate next)
        {
            this.Next = next;
        }

        public virtual Task BeforeInvoke(HttpContext context) => Task.CompletedTask;
        public virtual Task AfterInvoke(HttpContext context) => Task.CompletedTask;

        public virtual async Task Invoke(HttpContext context)
        {
            await this.BeforeInvoke(context);
            await this.Next(context);
            await this.AfterInvoke(context);
        }
    }
}
