﻿using ApiCore.Web.AppStart;
using ApiCore.Web.Models.Attributes;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Filters;

namespace ApiCore.Web.Controllers
{

    [RequestTimeFilter]
    [ModelStateValidationFilter]
    [JsonPayloadFilter]
    [Route($"{BaseApiController.RoutePrefixWithTrailingSlash}[controller]/[action]")]

    public class BaseApiController : Controller
    {
#if !RELEASE
        /// <summary>
        ///  "api/" or "" 
        /// </summary>
        public const string RoutePrefixWithTrailingSlash = "api/";

        /// <summary>
        ///  "/api" or "" 
        /// </summary>
        public const string RoutePrefixWithLeadingSlash = "/api";

        /// <summary>
        ///  "api" or "" 
        /// </summary>
        public const string RoutePrefix = "api";
#else
        public const string RoutePrefixWithTrailingSlash = "";
        public const string RoutePrefixWithLeadingSlash = "";
        public const string RoutePrefix = "";
#endif

        public BaseApiController()
        {

        }

        //protected MySqlConnection GetConnection() => new MySqlConnection(Config.Instance.SqlConnectionString.Value);

        public override void OnActionExecuting(ActionExecutingContext context)
        {
            // Do a bunch of stuff here if needed. Stuff like validation.
            base.OnActionExecuting(context);
        }

        public override void OnActionExecuted(ActionExecutedContext context)
        {
            // Make sure HTML helpers get values from MODEL and not modelstate. (Except for validation errors)
            ModelState.ToList().Where(x => x.Value != null).Select(x => x.Value!)
                .ToList().ForEach(x => { x.AttemptedValue = null; x.RawValue = null; });

            // Do a bunch of stuff here if needed. Stuff like validation.
            base.OnActionExecuted(context);
        }

        //protected async Task LogAction(string action)
        //{
        //    using var conn = this.GetConnection();
        //    await conn.ExecuteAsync("INSERT INTO `edit_history` (`action`) VALUES (@action)", new { action });
        //}
    }
}