using ApiCore.Common;
using ApiCore.Web;
using ApiCore.Web.Controllers;
using ApiCore.Web.Models;

// dotnet test --filter "FullyQualifiedName=ApiCore.Tools.DeployWeb.DeployToWebServer"
Console.WriteLine($"Starting app at {DeploymentInfoController.DeploymentTime.Value}");
Host.CreateDefaultBuilder(args)
    .ConfigureAppConfiguration((hostingContext, config) =>
    {
        string envName = hostingContext.HostingEnvironment.EnvironmentName;
        if (envName == "Development")
        {
            //config.AddGoogleSecretsManager<AppSettings>(@"D:\git\api.taylorlove.info\google-creds.json", "apicore_config_develop");
            config.AddJsonFile("appsettings.Development.json",
                optional: false,
                reloadOnChange: true);
        }
        else
        {
            config.AddJsonFile("appsettings.json",
                optional: false,
                reloadOnChange: true);
        }

    })
    .ConfigureWebHostDefaults(webBuilder =>
    {
#if !RELEASE
        Console.WriteLine("DEBUG MODE ON");
#else
        Console.WriteLine("DEBUG MODE OFF");
#endif
        webBuilder.UseStartup<Startup>()
        .PreferHostingUrls(true)
#if !RELEASE
        .UseUrls(new string[] { "https://localhost:5002" });
#else
        .UseUrls(new string[] { "http://localhost:5002" });
#endif
    })
    .Build()
    .Run();
